@echo off
goto intro

rem Requirements:

rem   - oggdec.exe: [RareWares](https://rarewares.org/index.php)
rem   - If WSH is enabled on Windows NT/2000 or later, Unicode filenames can be handled.
rem     https://docs.microsoft.com/en-us/previous-versions/visualstudio/visual-studio-2010/2z6exc9e%28v%3Dvs.100%29

rem _decodeU.bat: https://hitkey.nekokan.dyndns.info/diary2001.php#D200223
rem   * 2020-02-23: v0.0.1


:intro
    ver|find "Windows 95">NUL
    if not errorlevel 1 goto win9x

    ver|find "Windows 98">NUL
    if not errorlevel 1 goto win9x

    ver|find "Windows Millennium">NUL
    if not errorlevel 1 goto win9x

    cscript|find "Version">NUL
    if not errorlevel 1 goto js

    oggdec *.ogg
    exit

:js
    if exist "%Temp%\zzzzzz.js" del "%Temp%\zzzzzz.js"
    copy nul "%Temp%\zzzzzz.js">NUL

echo /*jslint this */>>"%Temp%\zzzzzz.js"
echo /*global WScript, Enumerator */>>"%Temp%\zzzzzz.js"
echo.>>"%Temp%\zzzzzz.js"
echo // Config ====================================================================>>"%Temp%\zzzzzz.js"
echo.>>"%Temp%\zzzzzz.js"
echo // if necessary, specify full path ( E.g.: "D:\\RareWares\\oggdec.exe" )>>"%Temp%\zzzzzz.js"
echo var OGGDEC = "";>>"%Temp%\zzzzzz.js"
echo.>>"%Temp%\zzzzzz.js"
echo // ===========================================================================>>"%Temp%\zzzzzz.js"
echo.>>"%Temp%\zzzzzz.js"
echo (function (ws) {>>"%Temp%\zzzzzz.js"
echo     "use strict";>>"%Temp%\zzzzzz.js"
echo     try {>>"%Temp%\zzzzzz.js"
echo         ws.createObject("WScript.Shell");>>"%Temp%\zzzzzz.js"
echo     } catch (er) {>>"%Temp%\zzzzzz.js"
echo         ws.echo(er.message);>>"%Temp%\zzzzzz.js"
echo         ws.quit(1);>>"%Temp%\zzzzzz.js"
echo     }>>"%Temp%\zzzzzz.js"
echo     var err = function (m) {>>"%Temp%\zzzzzz.js"
echo         try {>>"%Temp%\zzzzzz.js"
echo             throw {>>"%Temp%\zzzzzz.js"
echo                 name: "SyntaxError",>>"%Temp%\zzzzzz.js"
echo                 message: m>>"%Temp%\zzzzzz.js"
echo             };>>"%Temp%\zzzzzz.js"
echo         } catch (e) {>>"%Temp%\zzzzzz.js"
echo             WScript.echo(e.name + ":\n" + e.message);>>"%Temp%\zzzzzz.js"
echo             WScript.quit(1);>>"%Temp%\zzzzzz.js"
echo         }>>"%Temp%\zzzzzz.js"
echo     };>>"%Temp%\zzzzzz.js"
echo     var numerizeChar = function (c) {>>"%Temp%\zzzzzz.js"
echo         var t = typeof c;>>"%Temp%\zzzzzz.js"
echo         if (t === "number") {>>"%Temp%\zzzzzz.js"
echo             return c;>>"%Temp%\zzzzzz.js"
echo         }>>"%Temp%\zzzzzz.js"
echo         if (t !== "string") {>>"%Temp%\zzzzzz.js"
echo             err("TypeError: " + t);>>"%Temp%\zzzzzz.js"
echo         }>>"%Temp%\zzzzzz.js"
echo         if (c.length !== 1) {>>"%Temp%\zzzzzz.js"
echo             err("Arg.length must be 1: " + c);>>"%Temp%\zzzzzz.js"
echo         }>>"%Temp%\zzzzzz.js"
echo         return c.charCodeAt(0);>>"%Temp%\zzzzzz.js"
echo     };>>"%Temp%\zzzzzz.js"
echo     var lt = function (a, b) {>>"%Temp%\zzzzzz.js"
echo         var x = numerizeChar(a);>>"%Temp%\zzzzzz.js"
echo         var y = numerizeChar(b);>>"%Temp%\zzzzzz.js"
echo         if (x === y) {>>"%Temp%\zzzzzz.js"
echo             return false;>>"%Temp%\zzzzzz.js"
echo         }>>"%Temp%\zzzzzz.js"
echo         return x === Math.min(x, y);>>"%Temp%\zzzzzz.js"
echo     };>>"%Temp%\zzzzzz.js"
echo     var lte = function lte (a, b) {>>"%Temp%\zzzzzz.js"
echo         var x = numerizeChar(a);>>"%Temp%\zzzzzz.js"
echo         var y = numerizeChar(b);>>"%Temp%\zzzzzz.js"
echo         if (x === y) {>>"%Temp%\zzzzzz.js"
echo             return true;>>"%Temp%\zzzzzz.js"
echo         }>>"%Temp%\zzzzzz.js"
echo         return x === Math.min(x, y);>>"%Temp%\zzzzzz.js"
echo     };>>"%Temp%\zzzzzz.js"
echo     var gt = function (a, b) {>>"%Temp%\zzzzzz.js"
echo         var x = numerizeChar(a);>>"%Temp%\zzzzzz.js"
echo         var y = numerizeChar(b);>>"%Temp%\zzzzzz.js"
echo         if (x === y) {>>"%Temp%\zzzzzz.js"
echo             return false;>>"%Temp%\zzzzzz.js"
echo         }>>"%Temp%\zzzzzz.js"
echo         return x === Math.max(x, y);>>"%Temp%\zzzzzz.js"
echo     };>>"%Temp%\zzzzzz.js"
echo     var gte = function (a, b) {>>"%Temp%\zzzzzz.js"
echo         var x = numerizeChar(a);>>"%Temp%\zzzzzz.js"
echo         var y = numerizeChar(b);>>"%Temp%\zzzzzz.js"
echo         if (x === y) {>>"%Temp%\zzzzzz.js"
echo             return true;>>"%Temp%\zzzzzz.js"
echo         }>>"%Temp%\zzzzzz.js"
echo         return x === Math.max(x, y);>>"%Temp%\zzzzzz.js"
echo     };>>"%Temp%\zzzzzz.js"
echo.>>"%Temp%\zzzzzz.js"
echo     //! https://github.com/mathiasbynens/String.prototype.codePointAt>>"%Temp%\zzzzzz.js"
echo     // v0.2.1 by @mathias>>"%Temp%\zzzzzz.js"
echo     if (!String.prototype.codePointAt) {>>"%Temp%\zzzzzz.js"
echo         (function () {>>"%Temp%\zzzzzz.js"
echo             var codePointAt = function (position) {>>"%Temp%\zzzzzz.js"
echo                 if (this === null) {>>"%Temp%\zzzzzz.js"
echo                     throw new TypeError();>>"%Temp%\zzzzzz.js"
echo                 }>>"%Temp%\zzzzzz.js"
echo                 if (this === void(0)) {>>"%Temp%\zzzzzz.js"
echo                     throw new TypeError();>>"%Temp%\zzzzzz.js"
echo                 }>>"%Temp%\zzzzzz.js"
echo                 var string = String(this);>>"%Temp%\zzzzzz.js"
echo                 var size = string.length;>>"%Temp%\zzzzzz.js"
echo                 var index = (position ? Number(position) : 0);>>"%Temp%\zzzzzz.js"
echo                 var first;>>"%Temp%\zzzzzz.js"
echo                 var second;>>"%Temp%\zzzzzz.js"
echo                 if (typeof index === "number") {>>"%Temp%\zzzzzz.js"
echo                     if (isNaN(index)) {>>"%Temp%\zzzzzz.js"
echo                         index = 0;>>"%Temp%\zzzzzz.js"
echo                     }>>"%Temp%\zzzzzz.js"
echo                 }>>"%Temp%\zzzzzz.js"
echo                 if (lt(index, 0)) {>>"%Temp%\zzzzzz.js"
echo                     return undefined;>>"%Temp%\zzzzzz.js"
echo                 }>>"%Temp%\zzzzzz.js"
echo                 if (gte(index, size)) {>>"%Temp%\zzzzzz.js"
echo                     return undefined;>>"%Temp%\zzzzzz.js"
echo                 }>>"%Temp%\zzzzzz.js"
echo                 var isHighSurrogate = function (code) {>>"%Temp%\zzzzzz.js"
echo                     if (gte(code, 0xD800)) {>>"%Temp%\zzzzzz.js"
echo                         return lte(code, 0xDBFF);>>"%Temp%\zzzzzz.js"
echo                     }>>"%Temp%\zzzzzz.js"
echo                     return false;>>"%Temp%\zzzzzz.js"
echo                 };>>"%Temp%\zzzzzz.js"
echo                 var isLowSurrogate = function (code) {>>"%Temp%\zzzzzz.js"
echo                     if (gte(code, 0xDC00)) {>>"%Temp%\zzzzzz.js"
echo                         return lte(code, 0xDFFF);>>"%Temp%\zzzzzz.js"
echo                     }>>"%Temp%\zzzzzz.js"
echo                     return false;>>"%Temp%\zzzzzz.js"
echo                 };>>"%Temp%\zzzzzz.js"
echo                 first = string.charCodeAt(index);>>"%Temp%\zzzzzz.js"
echo                 if (isHighSurrogate(first)) {>>"%Temp%\zzzzzz.js"
echo                     if (gt(size, index + 1)) {>>"%Temp%\zzzzzz.js"
echo                         second = string.charCodeAt(index + 1);>>"%Temp%\zzzzzz.js"
echo                         if (isLowSurrogate(second)) {>>"%Temp%\zzzzzz.js"
echo                             return (first - 0xD800) * 0x400>>"%Temp%\zzzzzz.js"
echo                                 + second - 0xDC00 + 0x10000;>>"%Temp%\zzzzzz.js"
echo                         }>>"%Temp%\zzzzzz.js"
echo                     }>>"%Temp%\zzzzzz.js"
echo                 }>>"%Temp%\zzzzzz.js"
echo                 return first;>>"%Temp%\zzzzzz.js"
echo             };>>"%Temp%\zzzzzz.js"
echo             String.prototype.codePointAt = codePointAt;>>"%Temp%\zzzzzz.js"
echo         }());>>"%Temp%\zzzzzz.js"
echo     }>>"%Temp%\zzzzzz.js"
echo.>>"%Temp%\zzzzzz.js"
echo     var fso = ws.createObject("Scripting.FileSystemObject");>>"%Temp%\zzzzzz.js"
echo     var shell = ws.createObject("WScript.Shell");>>"%Temp%\zzzzzz.js"
echo     var cur = fso.getAbsolutePathName("./");>>"%Temp%\zzzzzz.js"
echo     var folder = fso.getFolder(cur);>>"%Temp%\zzzzzz.js"
echo     var files = folder.Files;>>"%Temp%\zzzzzz.js"
echo     var en = new Enumerator(files);>>"%Temp%\zzzzzz.js"
echo     var ogg = /[\u0020-\[\]-\uFFFD]+\.[Oo][Gg][Gg]$/;>>"%Temp%\zzzzzz.js"
echo     var file = null;>>"%Temp%\zzzzzz.js"
echo     var base = null;>>"%Temp%\zzzzzz.js"
echo     var sufx = null;>>"%Temp%\zzzzzz.js"
echo     var temp = null;>>"%Temp%\zzzzzz.js"
echo     var scriptExec = null;>>"%Temp%\zzzzzz.js"
echo     var PREFIX = "___oggdec_temp";>>"%Temp%\zzzzzz.js"
echo     var i = 0;>>"%Temp%\zzzzzz.js"
echo     var j = 0;>>"%Temp%\zzzzzz.js"
echo     var results = [];>>"%Temp%\zzzzzz.js"
echo     var faileds = [];>>"%Temp%\zzzzzz.js"
echo     var nonoggs = [];>>"%Temp%\zzzzzz.js"
echo     var exists = [];>>"%Temp%\zzzzzz.js"
echo     var mayoggs = 0;>>"%Temp%\zzzzzz.js"
echo     var result = "";>>"%Temp%\zzzzzz.js"
echo     var entityify = (function () {>>"%Temp%\zzzzzz.js"
echo         var character = {>>"%Temp%\zzzzzz.js"
echo             "\u0022": "\u0026quot;",>>"%Temp%\zzzzzz.js"
echo             "\u0026": "\u0026amp;",>>"%Temp%\zzzzzz.js"
echo             "\u0027": "\u0026#x27;",>>"%Temp%\zzzzzz.js"
echo             "\u003C": "\u0026lt;",>>"%Temp%\zzzzzz.js"
echo             "\u003E": "\u0026gt;">>"%Temp%\zzzzzz.js"
echo         };>>"%Temp%\zzzzzz.js"
echo         return function (textNode) {>>"%Temp%\zzzzzz.js"
echo             textNode = textNode.replace(>>"%Temp%\zzzzzz.js"
echo                 /[\u0022\u0026\u0027\u003C\u003E]/g,>>"%Temp%\zzzzzz.js"
echo                 function (ch) {>>"%Temp%\zzzzzz.js"
echo                     return character[ch];>>"%Temp%\zzzzzz.js"
echo                 }>>"%Temp%\zzzzzz.js"
echo             );>>"%Temp%\zzzzzz.js"
echo             var str = [];>>"%Temp%\zzzzzz.js"
echo             var o = textNode.length;>>"%Temp%\zzzzzz.js"
echo             var p = 0;>>"%Temp%\zzzzzz.js"
echo             var codePoint = 0;>>"%Temp%\zzzzzz.js"
echo             while (lt(p, o)) {>>"%Temp%\zzzzzz.js"
echo                 codePoint = textNode.codePointAt(p);>>"%Temp%\zzzzzz.js"
echo                 str[str.length] = (>>"%Temp%\zzzzzz.js"
echo                     lt(codePoint, 0x7F)>>"%Temp%\zzzzzz.js"
echo                     ? textNode.charAt(p)>>"%Temp%\zzzzzz.js"
echo                     : "[U+" + codePoint.toString(16).toUpperCase() + "]">>"%Temp%\zzzzzz.js"
echo                 );>>"%Temp%\zzzzzz.js"
echo                 p += (lt(codePoint, 0xFFFF) ? 1 : 2);>>"%Temp%\zzzzzz.js"
echo             }>>"%Temp%\zzzzzz.js"
echo             return str.join("");>>"%Temp%\zzzzzz.js"
echo         };>>"%Temp%\zzzzzz.js"
echo     }());>>"%Temp%\zzzzzz.js"
echo     if (!fso.fileExists(OGGDEC)) {>>"%Temp%\zzzzzz.js"
echo         OGGDEC = "oggdec.exe";>>"%Temp%\zzzzzz.js"
echo         if (!fso.fileExists(OGGDEC)) {>>"%Temp%\zzzzzz.js"
echo             ws.echo("oggdec is not found.");>>"%Temp%\zzzzzz.js"
echo             ws.quit(1);>>"%Temp%\zzzzzz.js"
echo         }>>"%Temp%\zzzzzz.js"
echo     }>>"%Temp%\zzzzzz.js"
echo.>>"%Temp%\zzzzzz.js"
echo     ws.echo("Now decoding ...\n");>>"%Temp%\zzzzzz.js"
echo     while (!en.atEnd()) {>>"%Temp%\zzzzzz.js"
echo         file = en.item();>>"%Temp%\zzzzzz.js"
echo         i += 1;>>"%Temp%\zzzzzz.js"
echo         if (!ogg.test(file)) {>>"%Temp%\zzzzzz.js"
echo             nonoggs[nonoggs.length] = file.Name;>>"%Temp%\zzzzzz.js"
echo         } else {>>"%Temp%\zzzzzz.js"
echo             base = fso.getBaseName(file);>>"%Temp%\zzzzzz.js"
echo             sufx = fso.getExtensionName(file);>>"%Temp%\zzzzzz.js"
echo             if (fso.fileExists(base + ".wav")) {>>"%Temp%\zzzzzz.js"
echo                 exists[exists.length] = file.Name;>>"%Temp%\zzzzzz.js"
echo             } else {>>"%Temp%\zzzzzz.js"
echo                 temp = PREFIX + i;>>"%Temp%\zzzzzz.js"
echo                 while (fso.fileExists(temp + ".ogg")) {>>"%Temp%\zzzzzz.js"
echo                     temp = "_" + temp;>>"%Temp%\zzzzzz.js"
echo                 }>>"%Temp%\zzzzzz.js"
echo                 file.Name = temp + ".ogg";>>"%Temp%\zzzzzz.js"
echo.>>"%Temp%\zzzzzz.js"
echo                 scriptExec = shell.run(OGGDEC + " " + temp + ".ogg", 0, true);>>"%Temp%\zzzzzz.js"
echo                 file.Name = base + "." + sufx;>>"%Temp%\zzzzzz.js"
echo                 if (scriptExec !== 0) { // [v1.9.7+] Errorlevel effective>>"%Temp%\zzzzzz.js"
echo                     faileds[faileds.length] = file.Name;>>"%Temp%\zzzzzz.js"
echo                 } else if (!fso.fileExists(temp + ".wav")) {>>"%Temp%\zzzzzz.js"
echo                     faileds[faileds.length] = file.Name;>>"%Temp%\zzzzzz.js"
echo                 } else {>>"%Temp%\zzzzzz.js"
echo                     fso.moveFile(temp + ".wav", base + ".wav");>>"%Temp%\zzzzzz.js"
echo                     j += 1;>>"%Temp%\zzzzzz.js"
echo                 }>>"%Temp%\zzzzzz.js"
echo                 results.length = 0;>>"%Temp%\zzzzzz.js"
echo             }>>"%Temp%\zzzzzz.js"
echo         }>>"%Temp%\zzzzzz.js"
echo         en.moveNext();>>"%Temp%\zzzzzz.js"
echo     }>>"%Temp%\zzzzzz.js"
echo     en = null;>>"%Temp%\zzzzzz.js"
echo     shell = null;>>"%Temp%\zzzzzz.js"
echo     fso = null;>>"%Temp%\zzzzzz.js"
echo     mayoggs = i - nonoggs.length;>>"%Temp%\zzzzzz.js"
echo     result = "Processing has been normally completed.">>"%Temp%\zzzzzz.js"
echo         + "\n\nOGG extension";>>"%Temp%\zzzzzz.js"
echo     if (mayoggs === 0) {>>"%Temp%\zzzzzz.js"
echo         result += " is not found.";>>"%Temp%\zzzzzz.js"
echo     } else if (mayoggs === 1) {>>"%Temp%\zzzzzz.js"
echo         result += ": 1 file found.\nDecoded WAV file: " + j + "/" + mayoggs;>>"%Temp%\zzzzzz.js"
echo     } else {>>"%Temp%\zzzzzz.js"
echo         result += ": " + mayoggs + " files found.\nDecoded WAV files: ">>"%Temp%\zzzzzz.js"
echo             + j + "/" + mayoggs;>>"%Temp%\zzzzzz.js"
echo     }>>"%Temp%\zzzzzz.js"
echo     if (faileds.length) {>>"%Temp%\zzzzzz.js"
echo         result += "\n\nFailed: " + faileds.length>>"%Temp%\zzzzzz.js"
echo             + "/" + mayoggs;>>"%Temp%\zzzzzz.js"
echo         i = 0;>>"%Temp%\zzzzzz.js"
echo         j = faileds.length;>>"%Temp%\zzzzzz.js"
echo         while (lt(i, j)) {>>"%Temp%\zzzzzz.js"
echo             result += "\n    " + entityify(faileds[i]);>>"%Temp%\zzzzzz.js"
echo             i += 1;>>"%Temp%\zzzzzz.js"
echo         }>>"%Temp%\zzzzzz.js"
echo     }>>"%Temp%\zzzzzz.js"
echo     if (exists.length) {>>"%Temp%\zzzzzz.js"
echo         result += "\n\nAlready exists: " + exists.length>>"%Temp%\zzzzzz.js"
echo             + "/" + mayoggs;>>"%Temp%\zzzzzz.js"
echo         i = 0;>>"%Temp%\zzzzzz.js"
echo         j = exists.length;>>"%Temp%\zzzzzz.js"
echo         while (lt(i, j)) {>>"%Temp%\zzzzzz.js"
echo             result += "\n    " + entityify(exists[i]);>>"%Temp%\zzzzzz.js"
echo             i += 1;>>"%Temp%\zzzzzz.js"
echo         }>>"%Temp%\zzzzzz.js"
echo     }>>"%Temp%\zzzzzz.js"
echo     ws.echo(result + "\n\nDone.");>>"%Temp%\zzzzzz.js"
echo     ws.quit(0);>>"%Temp%\zzzzzz.js"
echo }(WScript));>>"%Temp%\zzzzzz.js"

cscript "%Temp%\zzzzzz.js" //Nologo
if not errorlevel 1 goto eof

:win9x
    rem e.g. Win95 IE3 + WSH5.6 = could not locate automation class named "Wscript.Shell"
    oggdec *.ogg


:eof
    if exist "%Temp%\zzzzzz.js" del "%Temp%\zzzzzz.js"
    pause
    exit
